#!/usr/bin/python

from Foundation import *
import os

files = os.listdir(os.curdir)
for file in files:
	if file[-5:] == 'plist':
		obs = NSDictionary.dictionaryWithContentsOfFile_(file)
		obsName = obs.objectForKey_('observatory').objectForKey_('name')
		timeZone = obs.objectForKey_('observatory').objectForKey_('timeZone')
		if timeZone != None:
		
			if timeZone.endswith(':30'):
				timeZoneValue = abs(float(timeZone[:-3])) + 0.5
			elif timeZone.endswith(':15'):
				timeZoneValue = abs(float(timeZone[:-3])) + 0.25
			else:
				timeZoneValue = abs(float(timeZone))
		
			longitude = obs.objectForKey_('observatory').objectForKey_('coordinates').objectForKey_('longitude')
			sign = 1.0
			if longitude[0] < 0 or longitude[1] < 0 or longitude[2] < 0:
				sign = -1.0
			
#			if timeZoneValue != abs(timeZoneValue)*sign:
#				print obsName, timeZone, sign
				
			h = abs(round(timeZoneValue - 0.001))
			m = round((timeZoneValue - h)*60)
			if sign < 0:
				s = '-'
			else:
				s = '+'
			
			newTimeZone = '%s%02.0f:%02.0f'%(s, h, m)
			print newTimeZone
			
			timeZone = obs.objectForKey_('observatory').setObject_forKey_(newTimeZone, 'timeZone')
			obs.writeToFile_atomically_(file, True)
			
		else:
			print 'No TimeZone', obsName